import { type ILogger } from './ILogger';
import { LogLevel } from './LogLevel';
import { type VerboseType } from './VerboseType';
export declare class Logger implements ILogger {
    verbose: VerboseType;
    private readonly properties;
    private readonly currentIndent;
    private constructor();
    static start(verbose: VerboseType, functionName: string, details?: Record<string, unknown>, logLevel?: LogLevel.Value): Logger;
    get nextIndent(): Logger;
    log(functionName: string, details?: Record<string, unknown>, logLevel?: LogLevel.Value): void;
    get completeLog(): string;
}
